#include "flash_cc2538.h"

////flash address
#define PAGE_SIZE                2048
#define PAGE_TO_ERASE            14
//#define PAGE_TO_ERASE_START_ADDR (FLASH_BASE + PAGE_SIZE)
#define PAGE_TO_ERASE_START_ADDR (FLASH_BASE + (PAGE_TO_ERASE * PAGE_SIZE))

_sConfig		config;

void Flash_write(uint8_t *_data, int size)
{
    int32_t i32Res;
	int i;
  	i32Res = FlashMainPageErase(PAGE_TO_ERASE_START_ADDR);
	//
    for(i=0; i<PAGE_SIZE; i+=sizeof(config))
    {
        i32Res = FlashMainPageProgram((uint32_t*) _data, 
                                      PAGE_TO_ERASE_START_ADDR+i,
                                      size);
    }
	Uart1_Send("flash write!\n\r", 14); 
}

int flash_read( unsigned char *lpData, int _size )			// Mem block write
{
    int    			i=0;
	int32_t  Address;
    int32_t data_end_add = PAGE_TO_ERASE_START_ADDR + (_size*4);
 
    Address = PAGE_TO_ERASE_START_ADDR;                        		// EEPROM ۹
    while(Address < data_end_add) 
    {
        lpData[i] = HWREG(Address);
         Address += 4;
        i++;
    }
    return 1;
}

///////////////// Flash Write, Read  Start ///////////////////
void fn_config_write()
{
	Flash_write((uint8_t *)&config, sizeof(config));
}

// ٿε  ʱ  
void	fn_eeprom_init()
{
    int i = 0;       
    flash_read((uint8_t *)&config, sizeof(config));
	
  //  if(config.log[0] != '1')
    {      
      config.log[0] = '1';
	  config.lora_freq = LORA_FREQ_920700000;
	  config.lora_grup = LORA_GRUP_TEST;
	  config.sensor_id = 00001;
	  
	  config.sens_upunit  = 1;
	  
	  //
	  config.det_onth = DET_ONTH;
	  config.det_offth = DET_OFFTH;
	  config.det_onwait = DET_ONWAIT;
	  config.det_offwait = DET_OFFWAIT;
	  config.det_blup = DET_BLUP;
	  config.det_onwait = DET_ONWAIT;
	  config.det_longon = DET_LONGON;
	  
	  config.det_status   = DET_IDLE;
	  
	  config.ctrl_uvds = CTRL_UVDS;
	  
	  config.det_longonwait = DET_LONGONWAIT;
	  config.det_longonStableVal = DET_LONGON_STABLEVAL;
	  config.det_longonStableWait = DET_LONGON_STABLEWAIT;
	  
	 config.sens3_bl[0] = 0;
	 config.sens3_bl[1] = 0;
	 config.sens3_bl[2] = 0;   
	 config.bl_serch = 0; 
	 config.blz_stopcock[0] = 0;
	 config.blz_stopcock[1] = 0;
	 config.blz_stopcock[2] = 0;
	 config.blz_stopcock_tmp[0] = 0;
	 config.blz_stopcock_tmp[1] = 0;
	 config.blz_stopcock_tmp[2] = 0;	 
	 config.car_in_blz_stopcock[0] = 0;
	 config.car_in_blz_stopcock[1] = 0;
	 config.car_in_blz_stopcock[2] = 0;
	  
      fn_config_write();
    }
}
