#include "hal_LoRa_com.h"
#include "main.h"
#include "uart_comm.h"
#include <string.h>

#define LORA_MODE_SET  1
#define LORA_CONFIG_SET  2

#define FREQ_MAX 8
char lora_com_poz = LORA_POZ_MODE;
char sub_freq_poz = 0;
char data_analy_flag = 0;

int Freq_sel[FREQ_MAX] = {
  					9193,
					9195,
					9197,
					9199,
					9201,
					9203,
					9205,
					9207,					
}; 

char    byCommand_Buf[RX_QUEUE_SIZE];
int		lora_req_size = 0;
int 		req_data_size = 0;

void lora_mode_send(void);
void lora_data_send(unsigned char *_pData, int _size);
void lora_master_freq_set(void);
void lora_sub_freq_set(void);
void lora_rx_set(char _sel);
void lora_sleep_set(void);

void lora_init(void)
{
  lora_com.count = 0;
  lora_com.flag = DL_NOMAL;
  lora_req_size = 0; 
  lora_com_poz = LORA_POZ_MODE;
}

void lora_send_wait_init(void)
{
  lora_com.count = 0;
  lora_com.flag = DL_WAIT;
}


void ChangeHexToInt( unsigned char  *pszBuf, char *pdata, int _size )
{
	int		i, len = 0;
	BYTE    tmp = 0;
	//UARTprintf("\r\n",  tmp);
	for(i=0; i<_size; i++ )	
	{	  	
		if(pdata[i*2]>='A' && pdata[i*2]<='F' )
		  tmp = (pdata[i*2]-55)<<4;
		else if(pdata[i*2]>='a' && pdata[i*2]<='f' )
		  tmp = (pdata[i*2]-87)<<4;
		else
		  tmp = (pdata[i*2]-48)<<4;
		if(pdata[i*2+1]>='A' && pdata[i*2+1]<='F' )
		  tmp |= (pdata[i*2+1]-55);
		else if(pdata[i*2+1]>='a' && pdata[i*2+1]<='f' )
		  tmp |= (pdata[i*2+1]-87);
		else
		  tmp |= (pdata[i*2+1]-48);
	//	UARTprintf("%c",  tmp);	  
		pszBuf[i] = tmp;
	}
	//UARTprintf("\r\n",  tmp);
}

void data_serch_pot(char *put_pdata, char *pdata, int size)
{
	char	msg_buf[128];
	int		msg_size = 0, pos;
  	char	*p;
  	
   	pos = 0;
    p = strtok(pdata, ",");
	while(1)
	{
		if((p=='\0') || (pos>15)) 
		  		break;

		switch(pos)
		{
			case 0: 
					break;
			case 1: 
					break;
					
			case 2: 
					req_data_size = (BYTE)atoi(p);
					break;
			case 3: 
					if(req_data_size>0)
					{
						memset(msg_buf, 0, sizeof(msg_buf));
						memcpy(msg_buf, p, strlen(p));
					 }
					break;						
			default:				  
					break;
		}
		pos++;
		p = strtok('\0', ",");
	}	
//	UARTprintf("\r\n");
//	Uart2_Send(msg_buf, req_data_size*2);
	ChangeHexToInt(put_pdata, msg_buf, req_data_size);
	
}

void lora_req(void)
{
  char c = 0;
  char tmp = 0;
  int i=0;
  char tmp_buf[128];
    
  data_analy_flag = 0;
  while(GetRx1Char(&c))
  {
	  	if(lora_req_size == 0)
		{
			memset(byCommand_Buf, 0, sizeof(byCommand_Buf));
			req_data_size = 0; 
		}
		byCommand_Buf[lora_req_size++] = c;
		if(lora_req_size>RX_QUEUE_SIZE)
		{
		  UARTprintf("lora_req_size %d \r\n",  lora_req_size);
		  lora_req_size = 0;
		  memset(byCommand_Buf, 0, sizeof(byCommand_Buf));
		}
		if(c  == '\n')
		  data_analy_flag = 1;
  } 
  
  if(data_analy_flag)
  {	
	data_analy_flag = 0;
	for(i=0;i<lora_req_size;i++)
	{
		if(byCommand_Buf[i] == 'O')
		{
			if (!strncmp(&byCommand_Buf[i], "OK", 2))  // 
			{							  	
			  	if(lora_com_poz == LORA_POZ_MODE)
				{
					lora_com_poz = LORA_POZ_MASTER_FREQ_SET;
					lora_com.flag = DL_NOMAL;
				}		
				else if(lora_com_poz == LORA_POZ_MASTER_FREQ_SET)
				{
					lora_com_poz = LORA_POZ_RX_SET;
					lora_com.flag = DL_NOMAL;
					//lora_sleep_set();
					lora_rx_set(1);
				}
				else if(lora_com_poz == LORA_POZ_RX_SET)
				{
					lora_com_poz = LORA_POZ_WAIT;
					lora_com.flag = DL_NOMAL;
				}
				else if(lora_com_poz == LORA_POZ_MASTER_DATA_SEND)
				{
					//lora_com_poz = LORA_POZ_SUB_FREQ_SET;
					lora_com_poz = LORA_POZ_WAIT;
					lora_com.flag = DL_NOMAL;
				}
				else if(lora_com_poz == LORA_POZ_SUB_FREQ_SET)
				{
					lora_com_poz = LORA_POZ_SUB_DATA_SEND;
					lora_com.flag = DL_NOMAL;
				}	
				else if(lora_com_poz == LORA_POZ_SUB_DATA_SEND)
				{
					lora_com_poz = LORA_POZ_MASTER_FREQ_SET;
					lora_com.flag = DL_NOMAL;
				}		
				break;
			}
		}
		else if(byCommand_Buf[i] == 'a')
		{
			if (!strncmp(&byCommand_Buf[i], "at+recv", 7))  
			{							  	
/*				if(lora_com_poz == LORA_POZ_SUB_DATA_SEND)
				{
				  lora_com.flag = DL_NOMAL;
				  lora_com.count = 0;
				}
				else
				{
					lora_com.flag = DL_NOMAL;//
					lora_com_poz = LORA_POZ_WAIT;
				}
*/				
				lora_rx_set(1);			  
			  	data_serch_pot(tmp_buf, byCommand_Buf, strlen(byCommand_Buf));	
				if(req_data_size>0)
					data_analysys(tmp_buf, req_data_size);
				break;
			}
		}
	}
	lora_req_size = 0;
  }	
  
/*	if(lora_com.flag == DL_WAIT)
	{
	  if(lora_com.count++ > (500/timer_anlay))  //200ms ̻ Ÿ ó ϸ ׳ ʱȭ
	  {
		lora_com.count = 0;
		lora_com.flag = DL_NOMAL;
		lora_req_size = 0; 
		if(lora_com_poz != LORA_POZ_MODE)
			lora_com_poz = LORA_POZ_WAIT;
	  }
	}  
  */
}

void lora_poz_send(void)
{
   switch(lora_com_poz)
   {
	   case LORA_POZ_MODE:
		 lora_mode_send();
		 break;			 
		case LORA_POZ_MASTER_FREQ_SET:
		 lora_master_freq_set();
		 break;	
		 case LORA_POZ_RX_SET:
		 lora_rx_set(1);
		 break;	
/*		case LORA_POZ_SUB_FREQ_SET:
		 lora_sub_freq_set();
		 break;			 
		case LORA_POZ_MASTER_DATA_SEND:
		 //lora_data_send();
		 break;			 
//		case LORA_POZ_SUB_DATA_SEND:
	//	 lora_data_send();
		 break;			 */
       default:  //
		 break;
   }
}

//------------------------------------------------------------------------
//   : ByteString HEXCode 
//   : *pszBuf(ȯ ByteString), *pdata(ȯ HexCode), size(ȯ BYTE)
//  ȯ : none
//   : none
//------------------------------------------------------------------------
void send_lora(unsigned char *_pData, int _size)
{
  	BYTE send_buf[128];
	int len = 0, i;
	memset(send_buf, 0, sizeof(send_buf));
	sprintf(send_buf, "at+");
	len = 3;
	for(i=0;i<_size;i++)
	  send_buf[len++] =  _pData[i];

	send_buf[len++] = '\r';
	send_buf[len++] = '\n';
	
	Uart1_Send(send_buf, len);
	Uart2_Send(send_buf, len);
}

void ChangeIntToHex( char *pszBuf, unsigned char *pdata, int _size )
{
	int		i, len = 0;;
	BYTE    tmp = 0;
	
	for(i=0; i<_size; i++ )	
	{	  	
		tmp = ((pdata[i]&0xF0)>>4);
		if(tmp>=0 && tmp<=9)
		  tmp += 0x30;
		else if(tmp>=10 && tmp<=15)
		  tmp += 0x37;
		pszBuf[len++] = tmp;
		tmp = pdata[i]&0x0F;
		if(tmp>=0 && tmp<=9)
		  tmp += 0x30;
		else if(tmp>=10 && tmp<=15)
		  tmp += 0x37;
		pszBuf[len++] = tmp;
	}
}
/*
void ChangeIntToHex( char *pszBuf, unsigned char *pdata, int size )
{
	int		i;
	BYTE tmp_buf[128];
	memset(tmp_buf, 0, sizeof(tmp_buf));
	for(i=0; i<size; i++ )	
	{
	  sprintf(&tmp_buf[i*2], "%02x", pdata[i] );
	  //UARTprintf("tmp_buf %s, %c \r\n",  &tmp_buf[i*2], pdata[i]);	  
	}
	memcpy(pszBuf, tmp_buf, strlen(tmp_buf));
}
*/
// at+txc=1,1000,0210ab0101010101
void lora_data_send(unsigned char *_pData, int _size)
{
	if(lora_com_poz != LORA_POZ_WAIT)
	  return ;
	BYTE tmp_buf[128];
	BYTE tmp_send_buf[128];
	int size = 0, size1 = 0, i, len=0;
	BYTE xor_check = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	memset(tmp_send_buf, 0, sizeof(tmp_send_buf));
	sprintf(tmp_buf, "txc=1,1000,");
	
	ChangeIntToHex(tmp_send_buf, _pData, _size);	
	len = strlen(tmp_buf);
	size = strlen(tmp_send_buf);
	memcpy(&tmp_buf[len], tmp_send_buf, size);
	send_lora(tmp_buf, len+size);
	
	lora_send_wait_init();
}

void lora_mode_send(void)
{
    BYTE tmp_buf[128];
	int size = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	sprintf(tmp_buf, "mode=1");
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();
}

//  at+rf_config=919500000,7,0,1,8,14
void lora_master_freq_set(void)
{
    BYTE tmp_buf[128];
	int size = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	sprintf(tmp_buf, "rf_config=%d00000,7,0,1,8,14", Freq_sel[config.lora_freq]);	
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();
}

//  at+rf_config=919500000,7,0,1,8,14
void lora_sub_freq_set(void)
{
    BYTE tmp_buf[128];
	int size = 0;	
	if(sub_freq_poz == config.lora_freq)
	  sub_freq_poz++;
	if(sub_freq_poz >= FREQ_MAX)
		sub_freq_poz = 0;
	else 
	  	sub_freq_poz++;
	
	memset(tmp_buf, 0, sizeof(tmp_buf));
	sprintf(tmp_buf, "rf_config=%d00000,7,0,1,8,14", Freq_sel[sub_freq_poz]);
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();	
}

//  at+rxc=1, at+rx_stop
void lora_rx_set(char _sel)
{
    BYTE tmp_buf[128];
	int size = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	if(_sel)
		sprintf(tmp_buf, "rxc=1", Freq_sel[config.lora_freq]);	
	else
	  	sprintf(tmp_buf, "rx_stop", Freq_sel[config.lora_freq]);	
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();
}

//  at+sleep ƹ Է̳  
void lora_sleep_set(void)
{
    BYTE tmp_buf[128];
	int size = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	sprintf(tmp_buf, "sleep", Freq_sel[config.lora_freq]);	
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();
}

void lora_version_send(void)
{
    BYTE tmp_buf[128];
	int size = 0;
	memset(tmp_buf, 0, sizeof(tmp_buf));
	sprintf(tmp_buf, "version");
	send_lora(tmp_buf, strlen(tmp_buf));
	
	lora_send_wait_init();
}