#include "hal_adc.h"
#include "main.h"
#include "sn_sampling.h"

uint16_t
alsRead(uint32_t  _sel)
{
    uint16_t ui1Dummy;

    //
    // Trigger single conversion on AIN6 (connected to LV_ALS_OUT).
    //
    SOCADCSingleStart(_sel);

    //
    // Wait until conversion is completed
    //
    while(!SOCADCEndOfCOnversionGet())
    {
    }

    //
    // Get data and shift down based on decimation rate
    //
    ui1Dummy = SOCADCDataGet();
    //return(ui1Dummy >> SOCADC_12_BIT_RSHIFT);
	return(ui1Dummy >>3);
}

void ADC_read(unsigned char *p_data)
{
	unsigned int mag_result, bat_result;
  	mag_result = alsRead(SOCADC_AIN6);
	bat_result = alsRead(SOCADC_AIN7);	
	p_data[0] = mag_result/256;
	p_data[1] = mag_result%256;
	p_data[2] = bat_result/256;
	p_data[3] = bat_result%256;
}
