#include <stdbool.h>
#include <stdint.h>
#include "hw_init.h"
#include "main.h"
#include "uart_comm.h"
#include "hw_memmap.h"
#include "hw_sys_ctrl.h"
#include "hw_uart.h"
#include "debug.h"
#include "interrupt.h"
#include "uart.h"
#include "gptimer.h"



void
Timer0BIntHandler(void);

void RCC_Configuration(void)
{
	//
    // Enable UART peripheral module
    //
    
}

void interrupt_init(void)
{
 // 	IntMasterEnable();
  	//extern io ͷƮ 
//	GPIOIntTypeSet(GPIO_A_BASE, EXAMPLE_GPIO_PIN, GPIO_FALLING_EDGE);  //interrupt fall	
//	GPIOPinIntEnable(GPIO_A_BASE, EXAMPLE_GPIO_PIN);
//	IntEnable(GPIO_A_BASE);  //Ŭ ο̺ 
	
	//sleepmode
//	IntEnable(INT_SMTIM);
	// Set timer to 10000 above current value
    //
  //  ui32Val = SleepModeTimerCountGet();
  //  SleepModeTimerCompareSet(ui32Val + 10000);
	
}

void gpio_init(void)
{
  //  GPIOPinTypeGPIOInput(GPIO_A_BASE, EXAMPLE_GPIO_PIN);  //input
	//GPIOPinTypeGPIOOutput(GPIO_A_BASE, EXAMPLE_GPIO_PIN);  //output
  //  IOCPadConfigSet(GPIO_A_BASE, EXAMPLE_GPIO_PIN, IOC_OVERRIDE_PUE);  //pull up
	
   // GPIOPinTypeGPIOInput(GPIO_B_BASE, EXAMPLE_GPIO_PIN);  //input
	GPIOPinTypeGPIOOutput(GPIO_B_BASE, GPIO_PIN_2);  //output
    //IOCPadConfigSet(GPIO_B_BASE, EXAMPLE_GPIO_PIN, IOC_OVERRIDE_PUE);  //pull up
	GPIOPinWrite(GPIO_B_BASE, GPIO_PIN_2, GPIO_PIN_2);	

	//GPIOPinTypeGPIOInput(GPIO_C_BASE, LED_D601_PC0);  //input
	GPIOPinTypeGPIOOutput(GPIO_C_BASE, RUN_LED_PC0 | RF_PA_EN_PC3 | RF_LNA_EN_PC2 |PC4_PIN_I2C_POWER);  //output
    //IOCPadConfigSet(GPIO_C_BASE, RUN_LED_PC0, IOC_OVERRIDE_PUE);  //pull up
	GPIOPinWrite(GPIO_C_BASE, RUN_LED_PC0, RUN_LED_PC0);	
	GPIOPinWrite(GPIO_C_BASE, PC4_PIN_I2C_POWER, 0);	
	GPIOPinWrite(GPIO_C_BASE, RF_PA_EN_PC3 | RF_LNA_EN_PC2, 0);	
	
	//GPIOPinTypeGPIOInput(GPIO_D_BASE, LED_D601_PC0);  //input
	GPIOPinTypeGPIOOutput(GPIO_D_BASE, RF_HGM_PD2);  //output
    //IOCPadConfigSet(GPIO_D_BASE, RUN_LED_PC0, IOC_OVERRIDE_PUE);  //pull up
	GPIOPinWrite(GPIO_D_BASE, RF_HGM_PD2, 0);		
}

void USART1_Init(uint32_t brate)
{
    // Enable UART peripheral module
  	SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_UART0);
	// Disable UART function
	UARTDisable(UART0_BASE);
    // Set IO clock as UART clock source
	UARTClockSourceSet(UART0_BASE, UART_CLOCK_PIOSC);	
  
  	//232 PA0, PA1
	IOCPinConfigPeriphOutput(GPIO_A_BASE, PA0_PIN_UART_TXD, IOC_MUX_OUT_SEL_UART0_TXD);  //UART1  
    GPIOPinTypeUARTOutput(GPIO_A_BASE, PA0_PIN_UART_TXD); 
    IOCPinConfigPeriphInput(GPIO_A_BASE, PA1_PIN_UART_RXD, IOC_UARTRXD_UART0); //UART1  
    GPIOPinTypeUARTInput(GPIO_A_BASE, PA1_PIN_UART_RXD);
	
	UARTConfigSetExpClk(UART0_BASE, SysCtrlClockGet(), brate,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                         UART_CONFIG_PAR_NONE));
	
	UARTIntDisable(UART0_BASE, 0x1FFF); 
    UARTIntRegister(UART0_BASE, &Uart1_EnQueue);
    UARTIntEnable(UART0_BASE, UART_INT_RX | UART_INT_RT); 	
    UARTEnable(UART0_BASE);	
}

void USART2_Init(uint32_t brate)
{
    // Enable UART peripheral module
  	SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_UART1);
	// Disable UART function
	UARTDisable(UART1_BASE);
    // Set IO clock as UART clock source
	UARTClockSourceSet(UART1_BASE, UART_CLOCK_PIOSC);	
  
  	//232 PA0, PA1
	IOCPinConfigPeriphOutput(GPIO_A_BASE, PA2_PIN_UART_TXD2, IOC_MUX_OUT_SEL_UART1_TXD);  //UART1  
    GPIOPinTypeUARTOutput(GPIO_A_BASE, PA2_PIN_UART_TXD2); 
    IOCPinConfigPeriphInput(GPIO_A_BASE, PA3_PIN_UART_RXD2, IOC_UARTRXD_UART1); //UART1  
    GPIOPinTypeUARTInput(GPIO_A_BASE, PA3_PIN_UART_RXD2);
	
	UARTConfigSetExpClk(UART1_BASE, SysCtrlClockGet(), brate,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                         UART_CONFIG_PAR_NONE));
	
	UARTIntDisable(UART1_BASE, 0x1FFF); 
    UARTIntRegister(UART1_BASE, &Uart2_EnQueue);
    UARTIntEnable(UART1_BASE, UART_INT_RX | UART_INT_RT); 	
    UARTEnable(UART1_BASE);	
}

//timer0 
void TIMER0_Init(void)
{
//
    // The Timer0 peripheral must be enabled for use.
    //
 	 SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_GPT0);    
//
    // Configure GPTimer0B as a 16-bit periodic timer.
    //
    TimerConfigure(GPTIMER0_BASE, GPTIMER_CFG_SPLIT_PAIR | 
                   GPTIMER_CFG_A_PERIODIC |GPTIMER_CFG_B_PERIODIC);

    //
    // Configure GPTimer0B clock prescaler for 255. This will make the 
    // effective timer clock be SYSCLOCK / 255.
    //
    TimerPrescaleSet(GPTIMER0_BASE, GPTIMER_B, 16);

    //
    // Set the GPTimer0B load value to 1sec by setting the timer load value 
    // to SYSCLOCK / 255. This is determined by:
    //      Prescaled clock = 16Mhz / 255
    //      Cycles to wait = 1sec * Prescaled clock
    //
    //TimerLoadSet(GPTIMER0_BASE, GPTIMER_B, SysCtrlClockGet() / 255);		
	TimerLoadSet(GPTIMER0_BASE, GPTIMER_B, WAKE_UP_TIME);		

    //
    // The following call will result in a dynamic interrupt table being used.
    // The table resides in RAM.
    // Alternatively SysTickIntHandler can be statically registred in your
    // application.
    // 
    TimerIntRegister(GPTIMER0_BASE, GPTIMER_B, Timer0BIntHandler);    
    
    //
    // Enable processor interrupts.
    //
    IntMasterEnable();     

    //
    // Configure the GPTimer0B interrupt for timer timeout.
    //    
    TimerIntEnable(GPTIMER0_BASE, GPTIMER_TIMB_TIMEOUT);    

    //
    // Enable the GPTimer0B interrupt on the processor (NVIC).
    //
    IntEnable(INT_TIMER0B);

    //
    // Enable GPTimer0B.
    //
    TimerEnable(GPTIMER0_BASE, GPTIMER_B);  
	 
}

void I2C_init(void)
{
//
    //  The I2C peripheral must be enabled before use.
    //
    SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_I2C);
    
    //
    // Do reset of I2C module
    //
    SysCtrlPeripheralReset(SYS_CTRL_PERIPH_I2C);
	
	// Configure I2C pins
  	GPIOPinTypeI2C(GPIO_C_BASE, PC5_PIN_I2C_SCL);
    GPIOPinTypeI2C(GPIO_C_BASE, PC6_PIN_I2C_SDA);
	
	//
    // Configure pins as peripheral input and output
    //
    IOCPinConfigPeriphInput(GPIO_C_BASE, PC5_PIN_I2C_SCL, 
                            IOC_I2CMSSCL);
    IOCPinConfigPeriphInput(GPIO_C_BASE, PC6_PIN_I2C_SDA,
                            IOC_I2CMSSDA);    
    IOCPinConfigPeriphOutput(GPIO_C_BASE, PC5_PIN_I2C_SCL,
                             IOC_MUX_OUT_SEL_I2C_CMSSCL);
    IOCPinConfigPeriphOutput(GPIO_C_BASE, PC6_PIN_I2C_SDA,
                             IOC_MUX_OUT_SEL_I2C_CMSSDA);          
	
    I2CMasterInitExpClk(SysCtrlClockGet(), true); //! 4. Set the SCL clock frequency in I2CM_TPR     
    I2CMasterEnable();                                //! 3. Enable the Master mode in I2C Module                
}
	
void ADC_init(void)
{
    //
    // Configure ALS output pin as hw controlled, no drive (same as for timer)
    //
    GPIOPinTypeTimer(GPIO_A_BASE, PA7_PIN_ADC_BAT|PA6_PIN_ADC_MAG);

    //
    // Configure ADC, Internal reference, 512 decimation rate (12bit)
    //
    //SOCADCSingleConfigure(SOCADC_12_BIT, SOCADC_REF_INTERNAL);          
	SOCADCSingleConfigure(SOCADC_12_BIT, SOCADC_REF_AVDD5);          
}

//####################### interrupt
//1ms Ÿ̸
void
Timer0BIntHandler(void)
{	
  //
    // Clear the timer interrupt flag.
    //
    TimerIntClear(GPTIMER0_BASE, GPTIMER_TIMB_TIMEOUT);  

    //
    // Update the periodic interrupt counter.
    //
    
	st_Time_1ms.count ++;
	if(st_Time_1ms.count >=1)
	{
	  st_Time_1ms.flag = 1;
	  st_Time_1ms.count = 0;
	}
	st_Time_50ms.count++;
	if(st_Time_50ms.count >(50/timer_anlay))
	{
	  st_Time_50ms.flag = 1;
	  st_Time_50ms.count = 0;
	}
	st_Time_100ms.count++;
	if(st_Time_100ms.count >(100/timer_anlay))
	{
	  st_Time_100ms.flag = 1;
	  st_Time_100ms.count = 0;
	}
	st_Time_1s.count++;
	if(st_Time_1s.count >(1000/timer_anlay))
	{
	  st_Time_1s.flag = 1;
	  st_Time_1s.count = 0;
	}
}
/*
void
GPIOAIntHandler(void)
{
    uint32_t ui32GPIOIntStatus;

    //
    // Get the masked interrupt status.
    //
    ui32GPIOIntStatus = GPIOPinIntStatus(GPIO_A_BASE, true);

    //
    // Simple debounce function wait for button de-press
    //
    while(!GPIOPinRead(GPIO_A_BASE, GPIO_A_BASE))
    {
    }
    
    //
    // Acknowledge the GPIO  - Pin n interrupt by clearing the interrupt flag.
    //
    GPIOPinIntClear(GPIO_A_BASE, ui32GPIOIntStatus);

    //
    // Set an interrupt flag to indicate an interrupt has occurred.
    //
    //g_bGPIOIntFlag = true;
}
*/