#ifndef __PACKET_TYPE_H__
#define __PACKET_TYPE_H__

// packet format --------------------------------------------------

// packet msg type ------------------------------------------------
// DATA GROUP
#define PT_D_ONOFF          0x10
#define PT_D_SIG            0x11
#define PT_D_ON             0x12
#define PT_D_RTMON          0x13
#define PT_D_MAXCODE        PT_D_RTMON

// MGMT GROUP
#define PT_M_TIME           0x20
#define PT_M_BAT            0x21
#define PT_M_LQI            0x22
#define PT_M_STATUS         0x23
#define PT_M_PARAM          0x24
#define PT_M_MAXCODE        PT_M_PARAM

// CTRL GROUP
#define PT_C_RESET          0x30
#define PT_C_GETTIME        0x31
#define PT_C_ECHO           0x32
#define PT_C_BAT            0x33
#define PT_C_LQI            0x34
#define PT_C_GETPARAM       0x35
#define PT_C_SETPARAM       0x36
#define PT_C_GETSTATUS	    0x37
#define PT_C_SIGACQ         0x38
#define PT_C_STOP           0x39
#define PT_C_GETBL          0x40
#define PT_C_MAXCODE        PT_C_GETBL

// packet sub type ------------------------------------------------
// status packet sub type
#define PS_ONOPER           0x00
#define PS_READY            0x01
#define PS_DETSIGVAL	    0x02
#define PS_DETWAIT		    0x03
#define PS_DETLONGON	    0x04
#define PS_DETBLUP		    0x05
#define PS_DETBLBAK		    0x06
#define PS_SIGACQ_READY     0x07
#define PS_MGMTINTV		    0x08
#define PS_GETPOTBL         0x09
#define PS_BLUPDATED        0x0A
#define PS_SIGUNSTABLE      0x0B
#define PS_DETSIGVAL_EX     0x0C              // 2015.11.04 _yj.kwon
#define PS_LONGON_NOTI      0x0D                // 2015.11.10 _yj.kwon
#define PS_BLOFFSETADAP_NOTI 0x0E               // 2015.11.13 _yj.kwon
#define PS_LONGON_BL_TRACKED_NOTI    0x0F    // 2016.03.01 _yj.kwon
#define PS_MAXCODE          PS_LONGON_BL_TRACKED_NOTI

// parameter type
#define PM_SENS_POTBL       0x00
#define PM_DET_THS          0x01
#define PM_DET_CNTS         0x02
#define PM_DET_BLUP         0x03
#define PM_DET_LONGON       0x04
#define PM_MGMT_INTVS	    0x05
#define PM_CTRL_UVDS        0x06        // 2015.10.12 _yj.kwon
#define PM_CTRL_BL          0x07        // 2015.11.04 _yj.kwon
#define PM_DET_LMT_FNL      0x08        // 2015.11.04 _yj.kwon
#define PM_CTRL_VBATT       0x09        // 2015.11.09 _yj.kwon
#define PM_DET_LONGON_LMT_FNL   0x0A    // 사용하지 않음. 2016.03.23 _yj.kwon //2015.11.13 _yj.kwon  
#define PM_SENS_SETRST      0x0B        // 2015.11.14 _yj.kwon
#define PM_CTRL_NOTI        0x0C        // 2016.03.23 _yj.kwon
#define PM_DET_PREDETECT2PREIDLE        0x0D    // 사용하지 않음. 2016.03.23 _yj.kwon // 2016.03.10 _yj.kwon
#define PM_SENS_ID        0x0E    // 20171218 jhsong add
#define PM_MAXCODE          PM_SENS_ID

// values ---------------------------------------------------------
#define PS_RESET_SW_WOSCAN  0x00
#define PS_RESET_SW_WSCAN   0x0F
#define PS_RESET_HW_WOSCAN  0xF0
#define PS_RESET_HW_WSCAN   0xFF

#endif
