/******************************************************************************
*  Filename:       edge_trigger_int.c
*  Revised:        $Date: 2013-04-10 10:04:18 +0200 (Wed, 10 Apr 2013) $
*  Revision:       $Revision: 9695 $
*
*  Description:    Setup a GPIO pin to interrupt on a falling edge.
*
*  Copyright (C) 2013 Texas Instruments Incorporated - http://www.ti.com/
*
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

//   https://devzone.nordicsemi.com/f/nordic-q-a/28408/flashing-nrf51882-with-iar-ide-and-st-link-v2-swd-mode


#include "main.h"
#include "uart_comm.h"

_sTime  st_Time_1ms;
_sTime  st_Time_5ms;
_sTime  st_Time_10ms;
_sTime  st_Time_20ms;
_sTime  st_Time_50ms;
_sTime  st_Time_100ms;
_sTime  st_Time_200ms;
_sTime  st_Time_300ms;
_sTime  st_Time_500ms;
_sTime  st_Time_1s;

_sTime  lora_com;

int timer_anlay = WAKE_UP_TIME/1870 ;
int run_led_count = 0;

int fram_number = 0;



void sleep_test(void)
{
  uint32_t ui32Val;
  //
    // Disable UART0 when in deep sleep
    //
 //   SysCtrlPeripheralDeepSleepDisable(SYS_CTRL_PERIPH_UART0);
    
    //
    // Let system enter powermode 2 when going to deep sleep
    //
    SysCtrlPowerModeSet(SYS_CTRL_PM_2);

    //
    // Enable the Sleep Timer wakeup
    //
    GPIOIntWakeupEnable(GPIO_IWE_SM_TIMER); 

    //
    // Enable sleep mode interrupt
    //
    IntEnable(INT_SMTIM);
    
    //
    // Set timer to 10000 above current value
    //
    ui32Val = SleepModeTimerCountGet();
    SleepModeTimerCompareSet(ui32Val + 10000);

    //
    // Display the timer value on the console.
    //
 //   UARTprintf("Timer val = %d\n", ui32Val);
    
    //
    // Wait for UART to be flushed
    //
 //   while(UARTBusy(UART0_BASE))
    {
    }
    
    //
    // Go to sleep
    //
    SysCtrlDeepSleep();

    //
    // Display the timer value on the console.
    //    
    ui32Val = SleepModeTimerCountGet();
 //   UARTprintf("Timer val = %d (after wakeup)\n", ui32Val);
}


//*****************************************************************************
//
// Configure Port A Pin 3 to interrupt on a falling edge.  The console will
// display a counter which will increment every time an interrupt occurs.
//
//*****************************************************************************
int
main(void)
{
int32_t i32Res;
uint32_t i;
uint8_t tmp_buf[128];
int send_count_test = 0;
  char pcStrInRam[16] = "Hello ... world!"; 
  //
    // Set the clocking to run directly from the external crystal/oscillator.
    // (no ext 32k osc, no internal osc)
    //
    SysCtrlClockSet(false, false, SYS_CTRL_SYSDIV_32MHZ);

    //
    // Set IO clock to the same as system clock
    //
    SysCtrlIOClockSet(SYS_CTRL_SYSDIV_32MHZ);
    
	//Ŭ ο̺
	RCC_Configuration();
	
	gpio_init();
//	interrupt_init();
	TIMER0_Init();
	USART1_Init(115200);
	USART2_Init(115200);
	
	fn_eeprom_init();    
	
	I2C_init();
	i2c_init_mag3110();
	
	ADC_init();
//	data_init();

	lora_init();
	
	detect_init();
	
	UARTprintf("###############################\r\n");
	UARTprintf("### START LORA PARK_SN  ###\r\n");
	UARTprintf("### VER0.1_20180524 JHSONG###\r\n");
	
    while(1)
    {
		if(st_Time_1ms.flag)
		{
		  	st_Time_1ms.flag = 0;
			if(run_led_count++ == 0)
			{
			  RUN_LED_PC0_ON();
			}
			else if(run_led_count == 500)
			{
			  RUN_LED_PC0_OFF();
			}
			else if(run_led_count == 999)
			  run_led_count=0;
			
			//lora data Ȯ			
			lora_req();			

		}
		if(st_Time_50ms.flag )
		{
		  	st_Time_50ms.flag  = 0;
			det_sensor_read();
			detect();
		}
		if(st_Time_100ms.flag )
		{
		  	st_Time_100ms.flag  = 0;

		}
		if(st_Time_1s.flag )
		{
		  	st_Time_1s.flag  = 0;
			
//			UARTprintf("x_result %d, y_result %d, z_result %d \r\n",  x_result, y_result, z_result);

			if(lora_com_poz < LORA_POZ_WAIT)
			{
				lora_poz_send();
			}
		    else if(lora_com_poz == LORA_POZ_WAIT)
			{
//			  		lora_com_poz = LORA_POZ_MASTER_DATA_SEND;		
			  //onoff_send();
			}
			
		//	lora_version_send();
			
		}

    }
}
