#include "sn_mgmt_param.h"

// mgmt_send_param ------------------------------------------
void mgmt_send_param(uint16 param, uint16 value)
{
    BYTE tmp_send_buf[64];
	int size = 0;
	 tmp_send_buf[size++] = config.lora_freq;
	tmp_send_buf[size++] = config.lora_grup;
	tmp_send_buf[size++] = config.sensor_id/256;
	tmp_send_buf[size++] = config.sensor_id%256;
	tmp_send_buf[size++] = PT_M_PARAM;
	tmp_send_buf[size++] = 1;
	tmp_send_buf[size++] = (uint8)param;
	
	switch(param) {

		case PM_SENS_POTBL:
			tmp_send_buf[size++] = (uint8)0;
			tmp_send_buf[size++] = (uint8)0;
			tmp_send_buf[size++] = (uint8)((0) >> 8);
			tmp_send_buf[size++] = (uint8)(sens3_blz[0]);      //jhsong x
			tmp_send_buf[size++] = (uint8)(sens3_blz[0] >> 8);
			tmp_send_buf[size++] = (uint8)(sens3_blz[1]);      //jhsong y
			tmp_send_buf[size++] = (uint8)(sens3_blz[1] >> 8);
			tmp_send_buf[size++] = (uint8)(sens3_blz[2]);      //jhsong z
			tmp_send_buf[size++] = (uint8)(sens3_blz[2] >> 8);
			tmp_send_buf[size++] = (uint8)(x_result);      //jhsong x
			tmp_send_buf[size++] = (uint8)(x_result >> 8);
			tmp_send_buf[size++] = (uint8)(y_result);      //jhsong y
			tmp_send_buf[size++] = (uint8)(y_result >> 8);
			tmp_send_buf[size++] = (uint8)(z_result);      //jhsong z
			tmp_send_buf[size++] = (uint8)(z_result >> 8);   
			tmp_send_buf[size++] = (uint8)(sens3_blz[3]);      //jhsong z
			tmp_send_buf[size++] = (uint8)(sens3_blz[3] >> 8);
			tmp_send_buf[size++] = (uint8)0;      //jhsong z
			tmp_send_buf[size++] = (uint8)(0 >> 8);   
			break;
			
		case PM_DET_THS:
			tmp_send_buf[size++] = (uint8)(config.det_onth);
			tmp_send_buf[size++] = (uint8)(config.det_offth);
			break;
			
		case PM_DET_CNTS:                
			//tmp_send_buf[size++] = (uint8)(config.det_onwait);
			//tmp_send_buf[size++] = (uint16)(config.det_offwait);
			//*lenp     = 0x07;
			// 2015.10.12 _yj.kwon
			tmp_send_buf[size++] = (uint8)(config.det_onwait);
			tmp_send_buf[size++] = (uint8)(config.det_offwait);
			tmp_send_buf[size++] = (uint8)(config.det_offwait>>8);
			break;
			
		case PM_DET_BLUP:
			tmp_send_buf[size++] = (uint8)(config.det_blup);
			tmp_send_buf[size++] = (uint8)(config.det_blup >> 8);
			tmp_send_buf[size++] = (uint8)(config.sens_upunit);
			break;
			
		case PM_DET_LONGON:

			tmp_send_buf[size++] = (uint8)(config.det_longon);
			tmp_send_buf[size++] = (uint8)(config.det_longon >> 8);
			tmp_send_buf[size++] = (uint8)(config.det_longonwait);
			tmp_send_buf[size++] = (uint8)(config.det_longonwait >> 8);
			//*lenp     = 0x09;   
			// 2016.03.01 _yj.kwon
			tmp_send_buf[size++] = (uint8)(config.det_longonStableVal);
			tmp_send_buf[size++] = (uint8)(config.det_longonStableWait);
			tmp_send_buf[size++] = (uint8)(config.det_longonStableWait>>8);
			//*lenp     = 0x0C;                
			//2016.03.21 _yj.kwon
			tmp_send_buf[size++] = 0;//(uint8)(config.det_longonDet2PreidleCntLmt);
			break;
					
		// 2015.10.12 _yj.kwon    
		case PM_CTRL_UVDS:
				tmp_send_buf[size++] = (uint8)(config.ctrl_uvds);
				break;
		// 2015.11.04 _yj.kwon
		case PM_CTRL_BL:
	//		  tmp_send_buf[size++] = (uint8)(config.ctrl_bl);
			  break;
		// 2015.11.04 _yj.kwon
		case PM_DET_LMT_FNL:
		//	  tmp_send_buf[size++] = (uint8)(config.det_lmt_fnl);
			  break;
			  
		// 2015.11.09 _yj.kwon
		case PM_CTRL_VBATT:
	//		  tmp_send_buf[size++] = (uint8)(config.vbatt);
	//		  tmp_send_buf[size++] = (uint8)(config.vbatt >> 8);
			  break;
		// 2015.11.13 _yj.kwon
		case PM_DET_LONGON_LMT_FNL:
		  /*
			  tmp_send_buf[size++] = (uint8)(config.det_longon_lmt_fnl);
			  *lenp = 0x06;
		  */        // 미사용으로 삭제 _2016.03.23 _yj.kwon
			  break;
		// 2015.11.14 _yj.kwon
		case PM_SENS_SETRST:
		//	  tmp_send_buf[size++] = (uint8)(config.sens_setrst);
		//	  tmp_send_buf[size++] = (uint8)(config.sens_setrst>>8);
			  break;
			
		// 2016.03.01 _yj.kwon
		case PM_CTRL_NOTI:
		//	  tmp_send_buf[size++] = (uint8)(config.ctrl_noti);
			  break;
		 
		// 2016.03.10 _yj.kwon  20170316 jhsong 차량 있을때 기준값 설정 요청
		case PM_DET_PREDETECT2PREIDLE:
		  /*
			  tmp_send_buf[size++] = (uint8)(config.predetect2preidle);
			  tmp_send_buf[size++] = (uint8)(config.predetect2preidle>>8);
			  *lenp = 0x07;
		  */        // 미사용으로 삭제 _2016.03.23 _yj.kwon

		  break; 
		case PM_SENS_ID:{	
			tmp_send_buf[size++] = config.lora_freq;
			tmp_send_buf[size++] = config.lora_grup;  //macPib.macPANId 이걸 바꿔 줘야 됨				
			tmp_send_buf[size++] = config.sensor_id/256;  //
			tmp_send_buf[size++] = config.sensor_id%256;  //
		  }
		  break;         
    }
}

// mgmt_set_param ------------------------------------------
void mgmt_set_param(uint8 * _pData)
{
    uint8  save_c = FALSE;
    uint8  save_d = FALSE;
    uint8  tmp;
	uint16  tmp_1;
	int len = 0;
             
    // extract values
    switch(_pData[len++]) {

        case PM_SENS_POTBL:
            _pData[len++];
            tmp_1 = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
            //add jhsong 
            len += 2;
            sens3_blz[0] = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
            len += 2;
            sens3_blz[1] = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
            len += 2;
            sens3_blz[2] = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
			len += 2;
            sens3_blz[3] = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
			return;
            break;
                
        case PM_DET_THS: {
                uint8 onth, offth;
                    
                onth  = _pData[len++];
                offth = _pData[len];

                if(onth == 0) onth = DET_ONTH;
                else config.det_onth = onth;
                    
                if(offth == 0) offth = DET_ONTH;
                else config.det_offth = offth;
                
                save_d = TRUE;
            }
            break;;
                
        case PM_DET_CNTS: {
                uint8 onwait;
                uint16 offwait;
                    
                onwait  = _pData[len++];
                offwait = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);  // 2015.10.12 _yj.kwon
                    
                if(onwait == 0) onwait = DET_ONWAIT;
                else config.det_onwait = onwait;

                if(offwait == 0) offwait = DET_ONWAIT;
                else config.det_offwait = offwait;                    
                save_d       = TRUE;
            }
            break;
                
        case PM_DET_BLUP: {
                uint16 blup;
                uint8  upunit;
                uint8  blbak;                
          
                blup    = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                len += 2;
                upunit  = _pData[len++];
                
                blbak   = _pData[len];   
                
                if(blup == 0) blup = DET_BLUP;
                else config.det_blup = blup;
                   

                save_d  = TRUE;
            }
            break;
                
        case PM_DET_LONGON: {
                uint16 longon;
                uint16 longonwait;
                uint8 longonStableVal;
                uint16 longonStableWait;
                uint8 longonDet2PreidleCntLmt;
                
                longon = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                    
                if(longon == 0) longon = DET_LONGON;
                else config.det_longon = longon;
                
                len += 2;
                longonwait = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                if(longonwait == 0) longonwait = DET_LONGONWAIT;
                config.det_longonwait = longonwait;
                
                // 2016.03.01 _yj.kwon
                len +=2;
                longonStableVal = _pData[len];
                
                if(longonStableVal == 0) longonStableVal = DET_LONGON_STABLEVAL;
                config.det_longonStableVal = longonStableVal;
                
                len +=1;
                longonStableWait = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                if(longonStableWait == 0) longonStableWait = DET_LONGON_STABLEWAIT;
                config.det_longonStableWait = longonStableWait;
                
                // 2016.03.21 _yj.kwon
                len +=2;
                longonDet2PreidleCntLmt = _pData[len];
    //            if(longonDet2PreidleCntLmt == 0) longonDet2PreidleCntLmt = DET_LONGON_DET2PREIDLECNT_LMT;
     //           config.det_longonDet2PreidleCntLmt = longonDet2PreidleCntLmt;
                
                save_d = TRUE;
            }
            break;

        // 2015.10.12 _yj.kwon
          case PM_CTRL_UVDS: {
                  uint8 uVds;
                  
                  uVds = _pData[len++];
                  
                  //if(uVds & 0x80) uVds |= 0x80;                 // 0x80: Enable _Power down mode (Sleep mode control)
                  //else if(!(uVds & 0x80)) uVds &= ~0x80;        // Disable _Power down mode
#if defined(DBG_MSG)                  
                  printf("\r\nCTRL_UVDS: 0x%x", uVds);
#endif
                  config.ctrl_uvds = (uint8)(uVds);
                  
                   save_d = TRUE;

			return;
          }
            break;
            
          // 2015.11.04 _yj.kwon
          case PM_CTRL_BL:
          {
                      uint8 nBl;
                      
                      nBl = _pData[len++];
#if defined(DBG_MSG)
                      printf("\r\nCTRL_BL: 0x%x", nBl);
#endif
                      save_d = TRUE;
          }
            break;
            
            // 2015.11.04 _yj.kwon
          case PM_DET_LMT_FNL:
                  {
                        uint8 nLmtFnl;
                        
                        nLmtFnl = _pData[len++];
#if defined(DBG_MSG)
                        printf("\r\nLMT_FNL: 0x%x", nLmtFnl);
#endif

                        save_d = TRUE;
                  }
                  break;
                  
                  // 2015.11.09 _yj.kwon
          case PM_CTRL_VBATT:  {
                uint16 nVbatt;
                    
                nVbatt = ((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                                    
  //              if(nVbatt == 0) nVbatt = VBATT;
                
//                config.vbatt = nVbatt;
                
#if defined(DBG_MSG)
                uint8 nBattLevel;
                nBattLevel= (uint8)mgmt_get_bat();
                printf("\r\nVBATT_CALC: 0x%x, adc_bat: %u, Batt: %x", nVbatt, bat, nBattLevel );                
#endif                

                save_d = TRUE;
            }
            break;
         
          // 2015.11.13 _yj.kwon
          case PM_DET_LONGON_LMT_FNL: {  //jhsong 20170329 통신주기 정상 응답으로 60초로 변경
            /*
                uint8 nLongonLmtFnl;
                
                nLongonLmtFnl = _pData[len++];
#if defined(DBG_MSG)
                printf("\r\nDET_LONGON_LMT_FNL: 0x%x", nLongonLmtFnl);                
#endif
                config.det_longon_lmt_fnl = (uint8)nLongonLmtFnl;
                save_d = TRUE;
            */        // 미사용으로 삭제 _2016.03.23 _yj.kwon
          }
		  return;
          break;   
          
       
            
          // 2016.03.10 _yj.kwon  20170316 jhsong 차량 있을때 기준값 설정 요청
    case PM_DET_PREDETECT2PREIDLE:{
      /*
                  uint16 nPredet2PreIdle;
                  
                  nPredet2PreIdle =((uint16)(_pData[len]))|(((uint16)_pData[len+1])<<8);
                  
                  if(nPredet2PreIdle == 0) nPredet2PreIdle = DET_PREDETECT2PREIDLE;
#if defined(DBG_MSG)
                  printf("\r\nPredetect2preidle: %u", nPredet2PreIdle);
#endif
                  config.predetect2preidle = nPredet2PreIdle;
                  save_d = TRUE;
      */        // 미사용으로 삭제 _2016.03.23 _yj.kwon
      
              //add jhsong
              tmp = _pData[len++];
              if(tmp == 0x01) //차량없이 기준값 재설정
              {
                dl_car_state = 0;
                config.bl_serch = 0;
              }
              else if(tmp == 0x02) //차량있는데 기준값 재설정
              {
                dl_car_state = 1;
                config.bl_serch = 1;
              }
              config.sens3_bl[0] = 0;
              config.sens3_bl[1] = 0;
              config.sens3_bl[2] = 0; 
              detect_init();
              //end add
              }
              break;   
	case PM_SENS_ID:{	
	  	
	  			config.lora_freq = _pData[len++]&0x007;
				config.lora_grup = _pData[len++];  //macPib.macPANId 이걸 바꿔 줘야 됨
	 			config.sensor_id = _pData[len]*256+_pData[len+1];  //
				save_d = TRUE;
              }
              break;   	  			
                  
            
    }
        
    // save flash
    if(save_d) fn_config_write();
	
}

